#include<iostream.h>
#include<fstream.h>
#include "PatchPoint.hpp"
#include "math/MathFuncs.hpp"

/*long int populatePatchPoints(vector<PatchPoint*>& pts, vector<Mesh>& pMesh){
  int i;
  Material *tmpMa;
  long int Vertices=0;
  for(MeshListItr itr=pMesh.begin();itr!=pMesh.end();itr++)
    {
      Vertices  += itr->m_nVertices;
      for(i=0;i < itr->m_nVertices;i++) {
	Vec3f coord, normals, difVal, emmsVal;
	for(int j=0;j<3;j++) {
	  coord[j] = itr->m_pVertices[i][j];
	  normals[j] = itr->m_pNormals[i][j];
	}
	tmpMa = itr->m_pMaterial;
	
	difVal[0] = tmpMa->m_diffuse.red;
	difVal[1] = tmpMa->m_diffuse.green;
	difVal[2] = tmpMa->m_diffuse.blue;
	emmsVal[0] = tmpMa->m_emmission.red;
	emmsVal[1] = tmpMa->m_emmission.green;
	emmsVal[2] = tmpMa->m_emmission.blue;
	PatchPoint* p=new PatchPoint(coord,normals,difVal,emmsVal,-1,0); //debugging only
	pts.push_back(p);
      }
    }
  return(Vertices);
  }*/


long int createPatchPoints(vector<PatchPoint*>& pts, char* filename) {
  
  float a,b,c;
  long int Vertices = 0;
  ifstream in;
  in.open(filename);

  while(in)
    {
      in>>a>>b>>c;
      Vec3f coord(a,b,c);	
      in>>a>>b>>c;
      Vec3f normals(a,b,c);
      in>>a>>b>>c;
      Vec3f difVal(a,b,c);
      in>>a>>b>>c;
      Vec3f emmsVal(a,b,c);
      Vertices++;
      PatchPoint* p=new PatchPoint(coord,normals,difVal,emmsVal,-1,0); //debugging to be removed
      pts.push_back(p);
    }
  
  in.close();
  
  if(pts.size() > 0)
    pts.pop_back();
  printf("No. of points :: %d \n", Vertices);
  return(Vertices);
}
