#ifndef __localexpasioncoefficients__
#define __localexpasioncoefficients__

#include "src/Radical.hpp"
#include "src/PatchPoint.hpp"
#include "ExpansionCoefficients.hpp"
#include "MathFuncs.hpp"

class LocalExpansionCoefficients : public ExpansionCoefficients {
 public:
	 LocalExpansionCoefficients(Vec3f center,int p): ExpansionCoefficients(center,p) {}
	 LocalExpansionCoefficients(Vec3f r,Vec3f n, float radiosity, Vec3f center, int p);
	 LocalExpansionCoefficients translateTo(Vec3f newCenter);
	 float evaluateAtPoint(Vec3f r,Vec3f n,float rho);
	 void addPatchPointLocal(PatchPoint* pp,int channel);
     void addTranslatedMultipole(MultipoleExpansionCoefficients* mecs);
	 void addTranslatedLocal(LocalExpansionCoefficients* mecs);
};

#endif
